UNIT uRATESPIEL;

(* ******************************************************************** *)
(* K L A S S E : TRateSpiel                                             *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.1  Demo-Version fr LOG IN                           *)
(* Autor       : S. Spolwig, OSZ-Handel I,  10997 Berlin                *)
(*                                                                      *)
(* Funktion    : Das Spiel erzeugt eine Geheimnummer, die mit           *)
(*               mglichst wenigen Versuchen zu erraten ist.            *)
(*                                                                      *)
(* Compiler    : MSDOS / TURBO Pascal V. 7.0                            *)
(*                                                                      *)
(* Aenderung   : V. 3.1   20-FEB-98  mit FENSTER                        *)
(* ******************************************************************** *)


INTERFACE
(* ========================== Export ================================== *)

USES
  BILDSCHIRM, FENSTER, GRAFIK, CHKBOX, TXTBOX, OSZLOGO,
  uSPIELZAHL,
  uZAEHLER;


type
   TRateSpiel = object
                  Geheimzahl,
                  Ratezahl        : TSpielzahl;
                  Versuchszaehler : TZaehler;

                  Programmfenster : CFEnster;

                  Statusmeldung,
                  Sysmeldung      : CTextbox;

                  Ratefenster,
                  Zaehlerfenster  : CFenster;

                  constructor Init;
                  procedure Spielen;   virtual;
                end;

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse    : -
Bezugsklassen : s.o.


Methoden
--------

Init

  Auftrag: alle Inits; Programmlayout, Spielanleitung anzeigen
  vorher : -
  nachher: alle init.



Spielen

  Auftrag: mehrere Durchgnge spielen bis beendet wird.
  vorher : ist init.
  nachher: ist beendet.

----------------------------------------------------------------------- *)

IMPLEMENTATION
(* ==================================================================== *)


constructor TRateSpiel.Init;
(* -------------------------------------------------------------------- *)
begin
   Programmfenster.Init(1,1,79,25,4,'R A T E S P I E L  - Demo-Version fr LOG IN    (c) S. Spolwig, 1999');
   StatusMeldung.Init(25,3,1,1,0,'');
   Statusmeldung.TextfarbeSetzen (WEISS,BLAU);

   Sysmeldung.Init(3,22,1,1,0,'');
   Sysmeldung.TextfarbeSetzen (GELB,ROT);

   Ratefenster.Init (30,8,12,3,3,'Ratezahl');
   Zaehlerfenster.Init (30,15,12,3,2,'Versuche');
   Geheimzahl.Init (1,1); (* zwar nicht zu sehen, muss aber initialisiert werden *)
   Ratezahl.Init (35,9);

   Logo.Zeigen;
   Sysmeldung.Einblenden (' na dann los ... . . . .');

   Screen.Leeren;
   Programmfenster.Zeigen;
   Ratefenster.Zeigen;
   Zaehlerfenster.Zeigen;
end;


procedure TRateSpiel.Spielen;
(* -------------------------------------------------------------------- *)
begin
  repeat
    Versuchszaehler.Init(35,16);
    Versuchszaehler.Zeigen;

    Geheimzahl.Erzeugen;
    Statusmeldung.TextZeigen (' Gib Deine Zahlen ein ..  .  . ');

    repeat
      Ratezahl.Eingeben;
      Versuchszaehler.Erhoehen;
      Versuchszaehler.Zeigen;

      if Ratezahl.IstGleich (Geheimzahl)
      then
        begin
          Screen.Beep(4);
          SysMeldung.Einblenden (' Gratuliere! Richtig geraten! ');
        end
      else
        if Ratezahl.IstKleiner (Geheimzahl)
        then SysMeldung.Einblenden ( '.. zu niedrig ... ')
        else SysMeldung.Einblenden (' .. zu hoch ... ');

      Ratezahl.Loeschen;
    until Ratezahl.IstGleich (Geheimzahl);

  until Checkbox.AbbruchGedrueckt;
end;


END.