UNIT uSPIELZAHL;

(* ******************************************************************** *)
(* K L A S S E : TSpielzahl                                             *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.0                                                    *)
(* Autor       : S. Spolwig, OSZ-Handel I,  10997 Berlin                *)
(*                                                                      *)
(* Aufgabe     : stellt ein Objekt fuer ganze Zahlen zur Verfuegung.    *)
(*                                                                      *)
(* Compiler    : Turbo Pascal 7.0 / MSDOS                               *)
(* kown bugs   :
(* ******************************************************************** *)

INTERFACE
(* ========================== Export ================================== *)

USES BILDSCHIRM,
     TXTBOX;


type
   TSpielzahl = object
                  Wert   : 0..100;
                  XPos,
                  YPos  : integer;

                  constructor Init (eineXPos, eineYPos : integer);
                  procedure Erzeugen;   virtual;
                  procedure Eingeben;   virtual;
                  procedure Zeigen;     virtual;
                  procedure Loeschen;   virtual;
                  function  IstGleich  (andereZahl : TSpielzahl ) : boolean; virtual;
                  function  IstKleiner (andereZahl : TSpielzahl)  : boolean; virtual;
                end;

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse    : -
Bezugsklassen : CFenster
benutze Module: -

Methoden
--------

Init (eineXPos, eineYPos : integer);

   Auftrag: Wert auf definierten Stand setzen; XPos, YPos uebergeben
   vorher : -
   nachher: Wert ist Null.


Erzeugen

   Auftrag: Zufallszahl im Bereich 0-100 erzeugen
   vorher : init.
   nachher: -


Eingeben

   Auftrag: Zahl auf der Tastatur eingben
   vorher : init.
   nachher: Wert hat eingebene Zahl


Zeigen

   Auftrag: Zahl auf den Bildschirm schreiben
   vorher : init.
   nachher: Wert wird angeeineYPosgt


IstGleich (andereZahl)

   Anfrage: ob Wert und andere Zahl gleich sind
   vorher : init.
   nachher: true, wenn beide gleich sind


IstKleiner (andereZahl)

   Anfrage: ob Wert kleiner als andere Zahl ist
   vorher : init.
   nachher: true, wenn Wert keleiner als andereZahl

----------------------------------------------------------------------- *)

IMPLEMENTATION
(* ==================================================================== *)


constructor TSpielzahl.Init (eineXPos, eineYPos: integer);
(* -------------------------------------------------------------------- *)
begin
  Wert  :=  0;
  XPos  := eineXPos;
  YPos  := eineYPos;
end;


procedure TSpielzahl.Erzeugen;
(* -------------------------------------------------------------------- *)
begin
  randomize;
  Wert := random(100)+1;
end; (* Erzeugen *)


procedure TSpielzahl.Eingeben ;
(* -------------------------------------------------------------------- *)
var
  Sysmeldung     : CTextbox;
  Z : integer;

begin
  Sysmeldung.Init(3,23,1,2,0,'');
  Sysmeldung.TextFarbeSetzen (GELB,ROT);

  Screen.Cursor(XPos,YPos);  readln(Wert);  (*  open house ! *)

  while ( Wert < 1) or ( Wert > 100 ) do
  begin
    Screen.Beep(1);
    Sysmeldung.Einblenden(' Falsche Eingabe ');
    Loeschen;
    Screen.Cursor(XPos, YPos); readln(Wert);
  end;
end; (* Eingeben *)


procedure TSpielzahl.Zeigen;
(* -------------------------------------------------------------------- *)
begin
  Screen.Cursor(XPos,YPos); write(Wert);
end;


procedure TSpielzahl.Loeschen;
(* -------------------------------------------------------------------- *)
begin
  Screen.TextfarbeSetzen(HELLGRAU);
  Zeigen;
  Screen.NormalVideo;
end;


function TSpielzahl.IstGleich (andereZahl : TSpielzahl) : boolean;
(* -------------------------------------------------------------------- *)
begin
  IstGleich := false;

  if Wert = andereZahl.Wert
  then IstGleich := true;
end;


function TSpielzahl.IstKleiner (andereZahl : TSpielzahl) : boolean;
(* -------------------------------------------------------------------- *)
begin
  IstKleiner := false;

  if Wert < andereZahl.Wert
  then IstKleiner := true;
end;


END. (* Unit *)