unit uSpielFenster;
(* ******************************************************************** *)
(* K L A S S E : TSpieleFenster                                         *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.0  - MVC Demo Version (LOG IN)                       *)
(* Autor       : (c) S. Spolwig, OSZ-Handel I,  10997 Berlin            *)
(* Aufgabe     : GUI fuer das Spiel Zahlenraten.                        *)
(* Compiler    : Turbo Pascal 7.0 / MSDOS  / DELPHI 3.0                 *)
(* Aenderung   : 24-JAN-99                                              *)
(* ******************************************************************** *)

interface
(* ==================================================================== *)
uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls,
   uRatespiel; (* import: TRatespiel *)

type
  TSpielFenster = class(TForm)
                    EingabeLbl   : TLabel;
                    Eingabefeld  : TEdit;
                    ZaehlerLbl   : TLabel;
                    EndeBtn      : TButton;
                    Zaehler      : TLabel;
                    MeldeLeiste  : TLabel;
                    GeheimLbl    : TLabel;
                    Programmkopf : TLabel;

                    procedure Init;
                    procedure FormCreate(Sender: TObject);
                    procedure Beenden(Sender: TObject);
                    procedure TipEingeben(Sender: TObject; var Key: Char);
                    procedure Zeigen(Sender: TObject);

                    procedure DatenAktualisieren (sp: TRatespiel);
                    procedure MaskeAktualisieren (sp: TRatespiel);
                  end;

var
 SpielFenster : TSpielFenster;
 Ratespiel    : TRatespiel;


implementation
(* ==================================================================== *)
{$R *.DFM}



procedure TSpielFenster.Init;
(* -------------------------------------------------------------------- *)
begin
  Ratespiel := TRatespiel.Init;
  EingabeFeld.Text := '';
  MeldeLeiste.Caption := 'Neues Spiel - neues Glck';
  MaskeAktualisieren(Ratespiel);
end;

procedure TSpielFenster.FormCreate(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Init;
end;

procedure TSpielFenster.Beenden(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Close
end;

procedure TSpielFenster.TipEingeben (Sender: TObject; var Key: Char);
(* -------------------------------------------------------------------- *)
begin
 if key = chr(13)
 then
   begin
      try
        DatenAktualisieren(Ratespiel);
        MeldeLeiste.Caption := Ratespiel.VergleichsErgebnis;
        MaskeAktualisieren(Ratespiel);
      except
        on EConvertError do
        begin
         MessageDlg(' Du hast einen ungltigen Wert eingegeben! ',mtWarning,[mbOK],0);
         exit;
        end;
    end;
  end;

 if Ratespiel.IstFertig
 then
   begin
     showmessage('Ende - du kannst aber auch gleich weitermachen');
     Init;
   end;
end;

procedure TSpielFenster.Zeigen(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Ratespiel.Init;
  MaskeAktualisieren(Ratespiel);
end;

procedure TSpielFenster.DatenAktualisieren (sp: TRatespiel);
(* -------------------------------------------------------------------- *)
begin
  with sp do
  begin
    Ratezahl.Setwert(strToInt(EingabeFeld.Text));
    VersuchsZaehler.Erhoehen;
  end;
end;

procedure TSpielFenster.MaskeAktualisieren (sp : TRatespiel);
(* -------------------------------------------------------------------- *)
begin
  with sp do
  begin
    Zaehler.Caption   := inttostr (Versuchszaehler.GetWert);
    GeheimLbl.Caption := inttostr(Geheimzahl.GetWert);  // quicky
  end;
end;


END.
